//-----------------------------------------------------------------------------
// File: wipe.h
//
// Desc: Header file wipe sample app
//-----------------------------------------------------------------------------
#ifndef AFX_WIPE_H__D4C76CAC_8DCB_4D66_93A9_CC43F5FF8814__INCLUDED_
#define AFX_WIPE_H__D4C76CAC_8DCB_4D66_93A9_CC43F5FF8814__INCLUDED_




//-----------------------------------------------------------------------------
// Defines, and constants
//-----------------------------------------------------------------------------
// TODO: change "DirectX AppWizard Apps" to your name or the company name
#define DXAPP_KEY        TEXT("Software\\DirectX AppWizard Apps\\wipe")

// Struct to store the current input state
struct UserInput
{
    // TODO: change as needed
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
};




//-----------------------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: Application class. The base class (CD3DApplication) provides the 
//       generic functionality needed in all Direct3D samples. CMyD3DApplication 
//       adds functionality specific to this sample program.
//-----------------------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
    BOOL                    m_bLoadingApp;          // TRUE, if the app is loading
    CD3DFont*               m_pFont;                // Font for drawing text
    ID3DXMesh*              m_pD3DXMesh;            // D3DX mesh to store teapot
    ID3DXMesh*              m_pD3DXMesh2;            // D3DX mesh to store torus
	IDirect3DTexture8*		m_pMask;
    UserInput               m_UserInput;            // Struct for storing user input 

    FLOAT                   m_fTeapotRotX;           // World rotation state X-axis
    FLOAT                   m_fTeapotRotY;           // World rotation state Y-axis
    FLOAT                   m_fTaurusRotX;           // World rotation state X-axis
    FLOAT                   m_fTaurusRotY;           // World rotation state Y-axis

protected:
    HRESULT OneTimeSceneInit();
    HRESULT InitDeviceObjects();
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
    HRESULT Render();
    HRESULT FrameMove();
    HRESULT FinalCleanup();
    HRESULT ConfirmDevice( D3DCAPS8*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    VOID    ReadSettings();
    VOID    WriteSettings();

public:
	float m_wipeTime;
	int m_curScene;		// 0=1st scene, 1=transition, 2=2nd scene
	int m_wipeDir;
	float m_wipeDelay;
	void RenderSecondScene();
	void RenderFirstScene();
	void RenderMask(float maskTime);
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
};


#endif // !defined(AFX_WIPE_H__D4C76CAC_8DCB_4D66_93A9_CC43F5FF8814__INCLUDED_)
